# ====================================================================
# Copyright (c) 1999 GlobeCom GCAB AB.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer. 
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#
# 3. All advertising materials mentioning features or use of this
#    software must display the following acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# 4. The names "GlobeCom Jukebox" and "GlobeCom" must not be used to
#    endorse or promote products derived from this software without
#    prior written permission. For written permission, please contact
#    hpj@globecom.net.
#
# 5. Products derived from this software may not be called "GlobeCom
#    Jukebox" nor may "GlobeCom" appear in their names without prior written
#    permission of the GlobeCom GCAB AB.
#
# 6. Redistributions of any form whatsoever must retain the following
#    acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# THIS SOFTWARE IS PROVIDED BY GLOBECOM GCAB AB ``AS IS'' AND ANY
# EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL GLOBECOM GCAB AB OR
# ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
# ====================================================================

use MPEG::MP3Info;
use DBI;

my $dbh=DBI->connect("dbi:mysql:database=$DBNAME",$DBUSER,$DBPASS) || die;

my $orguser=shift(@ARGV);
my $user;
if (!$orguser) {
    $user="IS NULL";
} else {
    $user="= '$orguser'";
}

sub fetchsetting {
    my $res=$dbh->prepare("select value from usersetting where name = ? and user = ?");
    $res->execute($_[0],$orguser);
    my $ret;

    if (!(($ret)=$res->fetchrow_array())) {
	$res=$dbh->prepare("select value from settings where name = ?");
	$res->execute($_[0]);
	($ret)=$res->fetchrow_array();
    }
    return $ret;
}

my $groupsize=fetchsetting("GROUPSIZE");
my $selcount=fetchsetting("PRESEL");
$selcount=20
    if (!$selcount);
my $selpri=fetchsetting("PRESELPRI");
$selpri=1001
    if (!$selpri);
my $toplist=fetchsetting("TOPLIST");
my $topk=fetchsetting("TOPLISTK")**(1.0/7.0);
$topk=1.2
    if (!$topk);
my $lastplayed=fetchsetting("LASTPLAYED");

my $ins=$dbh->prepare("insert into queue (pri,id,user) values (?,?,?)");
my $sel;

my $queue;
my $privqueue;

sub selectsong {
    my $onerow=0;
    my $now=time;
    my $current=0;
    my $excl=1;
    my @row;
    my $cmax=0;
    my @mult;
    my @size;
    my @id;
    while(my ($id,$lastplay,$pri,$toplist,$weight)=$sel->fetchrow_array()) {
	$weight=$pri
	    if (!$weight);
	if (int($pri/1000)>$cmax) {
	    $cmax=int($pri/1000);
	    @size=@mult=@id=();
	}
	$pri-=$cmax*1000;
	if ($pri>=0) {
	    if ($pri>0) {
		$excl=0;
	    }
	    push (@id,$id);
	    if ($lastplayed) {
		push (@size,$now-$lastplay);
	    } else {
		push (@size,1);
	    }
	    if ($toplist) {
		push (@mult,($weight*($lastplay+5*($topk**((time-902940490)/86400)))));
	    } else {
		push (@mult,$weight);
	    }
	}
    }
    my @current;
    for (my $i=0;$i<@id;) {
	$size[$i]*=($mult[$i]+$excl);
	if ($size[$i]>=1) {
	    my $lcur=$current;
	    $current+=$size[$i];
	    print STDERR "Internal error"
		if ($lcur>$current);
	    push (@current,$current);
	    $i++;
	} else {
	    splice(@id,$i,1);
	    splice(@size,$i,1);
	    splice(@mult,$i,1);
	}
    }
    srand($now);
    my $one=0;
    for (my $i=0;$i<$selcount&&@id;$i++) {
	my $this=rand($current);
	my $j;
	for ($j=0;$this>=$current[$j];$j++) {
	}
	if ($privqueue) {
	    $ins->execute($selpri,$id[$j],$privqueue);
	} else {
	    $ins->execute($selpri,$id[$j],undef);
	}
	$current-=$size[$j];
	$one=1;
	splice(@id,$j,1);
	splice(@size,$j,1);
	splice(@mult,$j,1);
	splice(@current,$j,1);
    }
    return $one;
}

sub updategroupsize {
    $dbh->do('update groups set size = 0');
    my $sth=$dbh->prepare('select count(*),groupid from groupmember group by groupid');
    $sth->execute();
    my $msize=0;

    while(my ($size,$group)=$sth->fetchrow_array) {
	$msize=$size
	    if ($msize<$size);
	$dbh->do("update groups set size = $size where id = $group");
    }
    return $msize;
}

sub emptyqueue {
    my $vol=$dbh->prepare("select id from volumes where (flags&2)=2 and length(mounted)>0");
    $vol->execute();
    my @ids;
    while(my ($volid)=$vol->fetchrow_array()) {
	push(@ids,$volid);
    }
    my $volidsel;
    if (@ids) {
	$volidsel="where ( volid is null or volid in (".join(",",@ids).") )";
    } else {
	$volidsel="where volid is null";
    }

    if ($groupsize) {
	updategroupsize;
	if ($orguser) {
	    $sel=$dbh->prepare("select a.id,unix_timestamp(a.lastplayed),sum(ifnull(d.enable,0)*ifnull(d.pri,1)),a.toplist,sum(ifnull(d.enable,0)*ifnull(d.pri,1)/c.size) ".
			       "from songs a left join groupmember b on a.id = b.songid ".
			       "left join groups c on b.groupid = c.id left join groupsetting d on c.id = d.groupid and d.user $queue ".
			       "$volidsel and toplist > 0 group by a.id order by a.artist");
	} else {
	    $sel=$dbh->prepare("select a.id,unix_timestamp(a.lastplayed),sum(c.enable*c.pri),a.toplist,sum(c.enable*c.pri/c.size) ".
			       "from songs a left join groupmember b on a.id = b.songid ".
			       "left join groups c on b.groupid = c.id ".
			       "$volidsel and toplist > 0 group by a.id order by a.artist");
	}
    } else {
	if ($orguser) {
	    $sel=$dbh->prepare("select a.id,unix_timestamp(a.lastplayed),sum(ifnull(c.enable,0)*ifnull(c.pri,1)),a.toplist ".
			       "from songs a left join groupmember b on a.id = b.songid ".
			       "left join groupsetting c on b.groupid = c.groupid and c.user $queue ".
			       "$volidsel and toplist > 0 group by a.id order by a.artist");
	} else {
	    $sel=$dbh->prepare("select a.id,unix_timestamp(a.lastplayed),sum(c.enable*c.pri),a.toplist ".
			       "from songs a left join groupmember b on a.id = b.songid ".
			       "left join groups c on b.groupid = c.id ".
			       "$volidsel and toplist > 0 group by a.id order by a.artist");
	}
    }
    $sel->execute();
    sleep (10)
	if (!selectsong);
}

my $genrandom=fetchsetting("GENRANDOM");
$privqueue=fetchsetting("PRIVATEQUEUE");
if (!$orguser) {
    $queue="IS NULL";
} else {
    $queue="= '$privqueue'";
}

my $slowtmp=fetchsetting("SLOWTMP");
my $slowpre=fetchsetting("SLOWPRE");
my $slowskip=fetchsetting("SLOWSKIP");

$dbh->do("delete from queue where queue.pri = 0 and user $queue");
$dbh->do("update settings set value = 0 where name = 'SONGLEN'");
$dbh->do("update settings set value = 0 where name = 'SONGPOS'");

exit 0
    if ($ARGV[0] eq "quit");

$dbh->do("delete from queue where queueid > 0 and toplist = 0 and user $queue")
    if ($ARGV[0] eq "presel");

my $continue;
do {
  song:
    $continue=0;
    my $sth=$dbh->prepare("select queue.queueid,queue.id,songs.file,songs.difvol,songs.length,songs.format,a.mounted,a.id,a.flags from queue left join songs on queue.id = songs.id ".
			  "left join volumes a on a.id = songs.volid where pri > 0 and queue.user $queue and (a.id is null || (length(a.mounted)>0 && (a.flags&2)=2)) order by pri,queueid limit 1");
    $sth->execute();
    my @row;
    if (!(@row=$sth->fetchrow_array())) {
	if ($genrandom) {
	    emptyqueue;
	} else {
	    exit(0);
	}
	$continue=1;
    } else {
	my ($queueid,$id,$file,$difvol,$length,$format,$mounted,$volid,$volflags)=@row;
	system("$AUMIX -w ".int(75+$difvol))
	    if ($ARGV[0] ne "novol");
	if ($mounted) {
	    $file=$mounted."/".$file;
	}
	if ($id>=0&&!-f $file&&(!$slowtmp||!-f "$slowtmp/$id.$format")) {
	    $continue=1;
	    if ($volid) {
		my $vol=$dbh->prepare("select flags from volumes where id = ?");
		$vol->execute($volid);
		my ($flags)=$vol->fetchrow_array;
	      nosong:
		if (($flags&4)==0) {
		    my $sng=$dbh->prepare("select file from songs where volid = ?");
		    $sng->execute($volid);
		    while(my ($file)=$sng->fetchrow_array) {
			if (-f $mounted."/".$file) {
			    last nosong;
			}
		    }
		    $dbh->do("update volumes set flags = flags & 0xfd where id = ".$volid);
		} else {
		    $continue=0;
		}
	    }
	    if ($continue) {
		$dbh->do("delete from queue where queueid = ".$queueid);
	    }
	}
	if (!$continue) {
	    $dbh->do('update queue set pri = 0 where queueid = '.$queueid);
	    if ($id>=0) {
		$dbh->do("update songs set played = played + 1, lastplayed = now() where id = ".$id);
		if ($slowtmp&&-f "$slowtmp/$id.$format") {
		    print "$slowtmp/$id.$format\n$format\n";
		    $continue=0;
		} elsif (($volflags&4==0)||!$slowskip) {
		    print "$file\n$format\n";
		    $continue=0;
		}
	    } else {
		print int(-$id)."\ncd\n";
		$continue=0;
	    }
	}
    }
} while ($continue);

if ($slowtmp&&$slowpre) {
    my $res=$dbh->prepare("select b.id,b.file,b.format,a.pri,c.mounted from queue a,songs b,volumes c where a.user $queue and a.id = b.id and b.volid = c.id and (c.flags&4)=4 order by pri,queueid");
    $res->execute();
    
    my @rows;
    my @row;

    my %files;

    while($slowpre>0&&(@row=$res->fetchrow_array)) {
	if ($row[3]>0) {
	    $files{$row[0].".".$row[2]}=$row[4]."/".$row[1];
	} else {
	    $files{$row[0].".".$row[2]}=undef;
	}
	$slowpre--;
    }

    opendir(DIR,$slowtmp) || exit 0;
    for my $file (readdir(DIR)) {
	if (-f "$slowtmp/$file") {
	    if (!exists $files{$file}) {
		unlink ("$slowtmp/$file");;
	    }
	}
    }
    closedir DIR;
    $dbh->disconnect();
    my @files;
    for my $key (keys %files) {
	if ($files{$key} && ! -f "$slowpre/$key") {
	    open(TMP,">$slowpre/$key");
	    close TMP;
	    push(@files,$key);
	}
    }
    if (@files&&!fork()) {
	system("renice 10 $$ >/dev/null");
	for my $key (@files) {
	    if ($files{$key}=~/:\/\//) {
		system($WGET,"-q","-O","$slowtmp/$key",$files{$key});
	    } else {
		system($CP,$files{$key},"$slowtmp/$key");
	    }
	}
	exit 0;
    }
} else {
    $dbh->disconnect();
}
