# ====================================================================
# Copyright (c) 1999 GlobeCom GCAB AB.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer. 
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#
# 3. All advertising materials mentioning features or use of this
#    software must display the following acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# 4. The names "GlobeCom Jukebox" and "GlobeCom" must not be used to
#    endorse or promote products derived from this software without
#    prior written permission. For written permission, please contact
#    hpj@globecom.net.
#
# 5. Products derived from this software may not be called "GlobeCom
#    Jukebox" nor may "GlobeCom" appear in their names without prior written
#    permission of the GlobeCom GCAB AB.
#
# 6. Redistributions of any form whatsoever must retain the following
#    acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# THIS SOFTWARE IS PROVIDED BY GLOBECOM GCAB AB ``AS IS'' AND ANY
# EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL GLOBECOM GCAB AB OR
# ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
# ====================================================================

exit
    if ($#ARGV!=2);

$SIG{CHLD}='IGNORE';

my ($id,$infile,$outfile)=@ARGV;

use DBI;

my $dbh=DBI->connect("dbi:mysql:database=$DBNAME",$DBUSER,$DBPASS) || die;

sub fetchsetting {
    my $res=$dbh->prepare("select value from settings where name = ?") || die;
    $res->execute($_[0]);
    my $ret;
    ($ret)=$res->fetchrow_array();
    return $ret;
}

my $incname=fetchsetting("ORGNAME");
my $voldir=fetchsetting("VOLDIR");

my $res=$dbh->prepare("select songid,file from ripqueue where id = ?") || die;
$res->execute($id);
my ($songid,$volid)=$res->fetchrow_array;

$res=$dbh->prepare("select file,artist,title,volume,format,volid from songs where id = ?") || die;
$res->execute($songid);
my ($file,$artist,$title,$album,$format,$ovolid)=$res->fetchrow_array;

my ($fart,$ftit,$fvol);

($fart=$artist)=~s/[^a-z0-9]+/_/ig;
($ftit=$title)=~s/[^a-z0-9]+/_/ig;
($fvol=$album)=~s/[^a-z0-9]+/_/ig;

my $dirname;
my $newname;
my $realpos;

if ($voldir&&$fvol) {
    $dirname=$fart."/".$fvol;
} else {
    $dirname=$fart;
}
if ($incname) {
    $newname=$dirname."/".$fart."-".$ftit.".$format";
} else {
    $newname=$dirname."/".$ftit.".$format";
}

$res=$dbh->prepare("select flags,mounted from volumes where id = ?") || die;
my ($flags,$mount,$oflags,$omount);

if ($ovolid) {
    $res->execute($ovolid);
    ($oflags,$omount)=$res->fetchrow_array;
    $file="$omount/$file";
} else {
    $oflags=2;
    $omount="/";
}

if ($volid) {
    $res->execute($volid);
    ($flags,$mount)=$res->fetchrow_array;
    $realpos="$mount/$newname";
    $dirname="$mount/$dirname";
} else {
    $flags=2;
    $mount="/";
    $realpos=$newname="$TARGETBASE/$newname";
    $dirname="$TARGETBASE/$dirname";
}

if ($mount eq $omount) {
    print "Can't move, mounted to same place\n";
    exit 2;
}

if (($oflags&3)!=2||!$omount) {
    print "Can't move because old volume is read only or unmounted\n";
    exit 2;
}

if (($flags&3)!=2||!$mount) {
    print "Can't move because old volume is read only or unmounted\n";
    exit 2;
}

if (-f $newname) {
    print "The file $newname already exists, can't move\n";
    exit 2;
}

if (!-d $dirname) {
    system($MKDIR,"-p",$dirname);
}

if (system($MV,$file,$realpos)) {
    print "Couldn't move file from $file to $realpos\n";
    exit 2;
}

$res=$dbh->prepare("UPDATE songs SET volid = ?, file = ? WHERE id = ?\n") || die;
$res->execute($volid,$newname,$songid);

$dbh->disconnect;

unlink ($infile);
print "\n";
exit 0;
