# ====================================================================
# Copyright (c) 1999 GlobeCom GCAB AB.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer. 
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#
# 3. All advertising materials mentioning features or use of this
#    software must display the following acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# 4. The names "GlobeCom Jukebox" and "GlobeCom" must not be used to
#    endorse or promote products derived from this software without
#    prior written permission. For written permission, please contact
#    hpj@globecom.net.
#
# 5. Products derived from this software may not be called "GlobeCom
#    Jukebox" nor may "GlobeCom" appear in their names without prior written
#    permission of the GlobeCom GCAB AB.
#
# 6. Redistributions of any form whatsoever must retain the following
#    acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# THIS SOFTWARE IS PROVIDED BY GLOBECOM GCAB AB ``AS IS'' AND ANY
# EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL GLOBECOM GCAB AB OR
# ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
# ====================================================================

exit
    if ($#ARGV!=2);

if (!$MPMF20) {
    print "mpmf20 not installed\n";
    exit 2;
}

$SIG{CHLD}='IGNORE';

my ($id,$infile,$outfile)=@ARGV;

use DBI;

$|=1;

my $dbh=DBI->connect("dbi:mysql:database=$DBNAME",$DBUSER,$DBPASS) || die;

open(UPLOAD,"-|") || do {
    open(STDERR,">&STDOUT");
    exec $MPMF20,"-i";
    die "Couldn't exec file";
};

while(<UPLOAD>) {
    print;
    exit 1;
}
close UPLOAD;
print "5%\n";
system($MPMF20,"-x","-i");
print "10%\n";

my @xarg=("-u");
my $xmem;

my $res=$dbh->prepare("select file from songs, programmember a where songid = songs.id and programid = $infile order by a.id") || die;
$res->execute;

my @files;

while(my($file)=$res->fetchrow_array) {
    push(@files,$file);
}

my $count=0;
for my $file (@files) {
    my $redo=0;
    do {
	print $file."\n";
	open(UPLOAD,"-|") || do {
	    open(STDERR,">&STDOUT");
	    exec $MPMF20,@xarg,$file;
	    die "Couldn't exec file";
	};
	$redo=0;
	while(<UPLOAD>) {
	    if (!$xmem) {
		print "Switching to extra memory for $file\n";
		unshift(@xarg,"-x");
		$xmem=1;
		$redo=1;
	    }
	    print;
	}
	close UPLOAD;
    } while($redo);
    $count++;
    print int(90*$count/int(@files))+10;
    print "%\n";
}
undef $res;
$dbh->disconnect;

print "\n";
