update settings set value = '4011' where name = 'VERSION';

insert into formats values ('mp3','MPEG Layer 3 using mpg123','playmp3.pl',0);
insert into formats values ('wav','WAV player','playwav.pl',1);
insert into formats values ('cd','CD Player, internal','playcd',0);

create table transformations (
	fromid		varchar(10) not null,
	toid		varchar(10) not null,
	priority	int not null,
	description	varchar(100) not null,
	program		varchar(100) not null,

	primary key (fromid,toid)
);

insert into transformations values ('url','%',10,'Ripping from remote URL','download.pl');
insert into transformations values ('%','del',-20,'Remove song','remove.pl');
insert into transformations values ('cd' ,'wav',-20,'Ripping from CD to WAV','ripping.pl');
insert into transformations values ('wav','mp3',30,'Encoding from WAV to MP3','encode.pl');
insert into transformations values ('mp3','analyse',40,'Analyse recording volume','difvol.pl');
insert into transformations values ('%','upload',-50,'Upload to other jukebox','upload.pl');
insert into transformations values ('vol','vol',-30,'Move from different volumes','movevol.pl');

create table ripqueue (
	id		int not null primary key auto_increment,
	songid		int,
	fromid		varchar(10) not null,
	toid		varchar(10) not null,
	artist		varchar(100) not null,
	title		varchar(100) not null,
	album		varchar(100),
	file		varchar(200),
	status		int,
	user		varchar(20),
	trackno		int,
	log		text
);

create table volumes (
        id	        int not null primary key auto_increment,
	flags		int not null,
	name		varchar(40) not null,
	mounted		varchar(255)
);
